---
sidebar_position: 15
description: List object versions and other functions to work with S3 in the Open Integration Package, a free open-source integration library for 1C:Enterprise 8, OneScript and CLI
keywords: [1C, 1С, 1С:Enterprise, 1С:Enterprise 8.3, API, Integration, Services, Exchange, OneScript, CLI, S3]
---

import Tabs from '@theme/Tabs';
import TabItem from '@theme/TabItem';

# List object versions
 Gets a list of all versions of objects in the selected bucket



`Function ListObjectVersions(Val Bucket, Val BasicData, Val Prefix = "", Val Version = "", Val Headers = Undefined, Val Directory = False) Export`

  | Parameter | CLI option | Type | Required | Description |
  |-|-|-|-|-|
  | Bucket | --bucket | String | &#x2714; | Bucket name |
  | BasicData | --basic | Structure Of KeyAndValue | &#x2714; | Basic request data. See GetBasicDataStructure |
  | Prefix | --prefix | String | &#x2716; | Filtering by prefix, if necessary |
  | Version | --ver | String | &#x2716; | Version ID for the beginning of the list |
  | Headers | --headers | Map Of KeyAndValue | &#x2716; | Additional request headers, if necessary |
  | Directory | --dir | Boolean | &#x2716; | True > Path style URL, False > Virtual hosted style URL |

  
  Returns:  Structure Of KeyAndValue - serialized JSON response from storage

:::tip
Method at AWS documentation: [ListObjectVersions](https://docs.aws.amazon.com/AmazonS3/latest/API/API_ListObjectVersions.html)
:::
<br/>


```bsl title="1C:Enterprise/OneScript code example"
    URL       = "storage-155.s3hoster.by";
    AccessKey = "BRN5RKJE67...";
    SecretKey = "NNhv+i9PrytpT8Tu0C1N...";
    Region    = "BTC";

    BasicData = OPI_S3.GetBasicDataStructure(URL, AccessKey, SecretKey, Region);

    Directory = True; // Formation URL in path-style
    Bucket = "";
    Prefix = "pic";
    Result = OPI_S3.ListObjectVersions(Bucket, BasicData, Prefix, , , Directory);
```
 

 <Tabs>
  
    <TabItem value="bash" label="Bash" default>
        ```bash
            # JSON data can also be passed as a path to a .json file
            
            oint s3 ListObjectVersions \
             --bucket "d09ba45c" \
             --basic "{'URL':'storage-564.s3hoster.by','AccessKey':'***','SecretKey':'***','Region':'BTC','Service':'s3'}" \
             --prefix "pic" \
             --dir true
        ```
    </TabItem>
  
    <TabItem value="bat" label="CMD/Bat" default>
        ```batch
            :: JSON data can also be passed as a path to a .json file
            
            oint s3 ListObjectVersions ^
             --bucket "d09ba45c" ^
             --basic "{'URL':'storage-564.s3hoster.by','AccessKey':'***','SecretKey':'***','Region':'BTC','Service':'s3'}" ^
             --prefix "pic" ^
             --dir true
        ```
    </TabItem>
</Tabs>


```json title="Result"
{
 "status": 200,
 "response": {
  "ListVersionsResult": {
   "Name": "d09ba45c",
   "Prefix": "pic",
   "KeyMarker": {},
   "NextVersionIdMarker": {},
   "VersionIdMarker": {},
   "MaxKeys": "***",
   "IsTruncated": "false",
   "Version": {
    "Key": "***",
    "LastModified": "2025-12-10T20:35:21.435Z",
    "ETag": "\"9e0176f87f6565a22f78e0f9b39a4d78\"",
    "Size": "2114023",
    "Owner": {
     "ID": "02d6176db174dc93cb1b899f7c6078f08654445fe8cf1b6ce98d8855f66bdbf4",
     "DisplayName": "minio"
    },
    "StorageClass": "STANDARD",
    "IsLatest": "true",
    "VersionId": "null"
   }
  }
 },
 "headers": {
  "Accept-Ranges": "bytes",
  "Date": "Wed, 10 Dec 2025 20:44:32 GMT",
  "Server": "MinIO",
  "Strict-Transport-Security": "max-age=31536000; includeSubDomains",
  "Vary": "Origin, Accept-Encoding",
  "X-Amz-Id-2": "9db21855adaa63c98221e7a7db59c17bf693f4833027894c70082214acf3a007",
  "X-Amz-Request-Id": "187FF577950296FE",
  "X-Content-Type-Options": "nosniff",
  "X-XSS-Protection": "1; mode=block",
  "Content-Length": "702",
  "Content-Type": "application/xml"
 }
}
```
